﻿Public Class Form1

    Dim SP As SPAxnCOMwrapSC.IAnalyzerSC


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Initial values for the frequency span
        TBStartHz.Text = "500.0"
        TBStopHz.Text = "5000.0"

        ' Populate the peak number combobox
        CBPeakNumber.Items.Add("1")
        CBPeakNumber.Items.Add("2")
        CBPeakNumber.Items.Add("3")
        CBPeakNumber.Items.Add("4")
        CBPeakNumber.Items.Add("5")
        CBPeakNumber.Items.Add("6")
        CBPeakNumber.Items.Add("7")
        CBPeakNumber.Items.Add("8")
        CBPeakNumber.Items.Add("9")
        CBPeakNumber.Items.Add("10")
        CBPeakNumber.SelectedIndex = 0

    End Sub

    Private Sub Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenAnalyzer.Click

        Cursor = Cursors.WaitCursor

        If SP Is Nothing Then
            'Launch the spectrum analyzer
            'SP = New SpectraPLUS_SCAutomationLib.SpectraPLUS_SCClass
            SP = New SPAxnCOMwrapSC.AnalyzerSC
            SP.Init()
        End If

        If SP Is Nothing Then
            MsgBox("Failure Opening SpectraPLUS-SC")
        Else
            ' Configure the settings
            'Note: Use the Load Configuration file to easily setup the analyzer
            'Example:  SP.LoadConfig("C:\SpectraPLUS_SC\Config\test1.cfg")

            SP.SetMode(0)  ' Real time mode
            SP.SetNumChannels(2)
            SP.SetSamplingRate(48000)
            SP.SetSamplingPrecision(24)
        End If

        Cursor = Cursors.Default

    End Sub

    Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRun.Click
        If SP Is Nothing Then
            MsgBox("SpectraPLUS-SC is not Open")
        Else
            SP.Run()
            DataTimer.Interval = 500
            DataTimer.Enabled = True
        End If
    End Sub

    Private Sub Stop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnStop.Click
        DataTimer.Enabled = False

        If SP Is Nothing Then
            MsgBox("SpectraPLUS-SC is not Open")
        Else
            SP.Stop()
        End If
    End Sub

    Private Sub Close_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClose.Click
        Close()
    End Sub

    Private Sub DataTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DataTimer.Tick
        GetResults()
    End Sub

    Private Sub GetResults()
        If SP Is Nothing Then

        Else
            Dim startHz As Single
            Dim stopHz As Single

            startHz = TBStartHz.Text
            stopHz = TBStopHz.Text

            Dim freq As Single
            Dim amp As Single

            Dim peakNum As Integer
            peakNum = CBPeakNumber.SelectedIndex

            ' Read the peak values from the analyzer and display them
            SP.GetPeakFrequencyNthSpan(0, peakNum, startHz, stopHz, freq)
            SP.GetPeakAmplitudeNthSpan(0, peakNum, startHz, stopHz, amp)
            TBFreq0.Text = freq
            TBAmp0.Text = amp

            SP.GetPeakFrequencyNthSpan(1, peakNum, startHz, stopHz, freq)
            SP.GetPeakAmplitudeNthSpan(1, peakNum, startHz, stopHz, amp)
            TBFreq1.Text = freq
            TBAmp1.Text = amp
        End If
    End Sub

    Private Sub TBStartHz_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TBStartHz.TextChanged
        GetResults()
    End Sub

    Private Sub TBStopHz_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TBStopHz.TextChanged
        GetResults()
    End Sub

    Private Sub CBPeakNumber_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CBPeakNumber.SelectedIndexChanged
        GetResults()
    End Sub
End Class
